import { ref as x, reactive as te, computed as ve, toRefs as Ve, defineComponent as ge, onMounted as De, resolveComponent as _, openBlock as i, createBlock as v, withCtx as o, createElementVNode as G, renderSlot as A, createVNode as s, unref as e, createElementBlock as N, Fragment as K, renderList as W, mergeProps as w, withModifiers as Ce, createTextVNode as q, toDisplayString as re, createCommentVNode as z, resolveDirective as Re, withDirectives as ye, createSlots as Ae, resolveDynamicComponent as Oe, normalizeProps as Te, guardReactiveProps as xe, withKeys as $e, vShow as Ue, isRef as Le } from "vue";
import { ElMessage as Me, ElMessageBox as Ee, ElNotification as Ne, ElButton as oe, ElButtonGroup as ze, ElDialog as Ke } from "element-plus";
import { useRoute as qe } from "vue-router";
const $ = x({
  debug: !1,
  mainMaxHeight: 700,
  isAfterMountQuery: !1,
  isOpenSearchForm: !1,
  Form_LabelWidth: 120,
  Dialog_Width: 800,
  Dialog_isFullscreen: !1,
  Dialog_isCloseOnPressEscape: !0,
  Dialog_isCloseOnClickModal: !1,
  Dialog_isFooterButton: !0,
  Table_isOpenIndex: !0,
  Table_isOpenMultipleSelection: !1,
  Table_isOpenExpand: !0,
  Table_ExpandColumn: 4,
  Table_MenuWidth: 200,
  Table_MenuAlign: "left",
  Page_PageSizes: [10, 20, 50, 100],
  Page_PageParams: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  Page_Layout: "->,total, sizes, prev, pager, next, jumper",
  Page_isHideOnSinglePage: !1,
  ApiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
}), d = x({
  CompRef: {},
  Mode: "add",
  DialogVisible: !1,
  tableLoading: !1,
  submitLoading: !1,
  DialogVisibleFooterButton: !0,
  ElementArrs: { filter: {}, editor: {}, column: {}, columns: {} },
  tableColumn: [],
  originalData: [],
  tableData: [],
  multipleSelection: [],
  uploadFiles: [],
  initSearchModel: {},
  initEditModel: {},
  searchFormValue: {},
  searchModel: {},
  editFormValue: {},
  editModel: {}
}), X = x({});
function ne(r) {
  let p;
  try {
    p = Array.isArray(r) ? [] : {}, r === null && (p = null);
  } catch {
    p = {};
  }
  for (const f in r)
    typeof r[f] == "object" ? p[f] = ne(r[f]) : p[f] = r[f];
  return p;
}
function Pe(...r) {
  function p(a) {
    return typeof a == "object" && Object.prototype.toString.call(a) === "[object Object]";
  }
  let f = arguments.length, m = arguments[0];
  p(m) || (m = {});
  for (let a = 1; a < f; a++) {
    let C = arguments[a];
    if (p(C))
      for (let D in C)
        D === "__proto__" || m === C[D] || m.hasOwnProperty(D) && (p(C[D]) ? m[D] = Pe(m[D], C[D]) : m[D] = C[D]);
  }
  return m;
}
function Ie(r, p) {
  let f = {}, m = Object.getOwnPropertyNames(r), a = Object.getOwnPropertyNames(p);
  return m.length === a.length && m.forEach((C) => {
    r[C] !== p[C] && (f[C] = p[C]);
  }), f;
}
const ae = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeBatchDeteleHandler: "beforeBatchDeteleHandler",
  afterBatchDeteleHandler: "afterBatchDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function je(r = { debug: !1 }) {
  const p = te({
    hooks: {}
  });
  return Object.keys(r).forEach((m) => {
    m !== "debug" && (p.hooks[m] = r[m]);
  }), {
    hookHandler: (m, a) => {
      let C = !1;
      try {
        r.debug && (console.group("DeBug\uFF1A", m), console.table(a.Data), console.groupEnd()), C = p.hooks[m](a);
      } catch {
        C = !0;
      }
      return C;
    }
  };
}
let B = {};
const de = x(), We = (r) => {
  de.value = r.CrudRequest, $.value = Pe($.value, r), be("\u3010\u521D\u59CB\u5316Options\u3011", r), B = { ...$.value };
}, Qe = (r) => {
  console.log(JSON.stringify(X.value)), JSON.stringify(X.value) !== "{}" && (X.value = {}, console.log("\u4E0D\u662F\u7A7A\u7684")), console.log("\u5F00\u59CB\u8D4B\u503C"), X.value = r, Je(X.value.source), $.value = Pe($.value, X.value), be("UseCrudStates\u4F20\u53C2\u3010props\u3011", X.value), be("\u3010DefParams\u3011", $.value), be("\u3010CrudStates\u3011", d.value);
};
function he() {
  return { ...Ve($.value) };
}
function k() {
  return { ...Ve(d.value) };
}
function He() {
  return { ...Ve(X.value) };
}
const Be = () => {
  const r = X.value, p = (t) => {
    let n = {};
    return r.rowKey && (n[r.rowKey] = t[r.rowKey]), r.rowKeys && r.rowKeys.forEach((F) => {
      n[F] = t[F];
    }), n;
  }, { hookHandler: f } = je(r.hooks);
  function m() {
    d.value.tableLoading = !0;
    const t = te({ ...d.value.initSearchModel, ...d.value.searchModel });
    for (const n in t)
      typeof t[n] == "string" && (t[n] = t[n].trim(), t[n] === "" && (t[n] = void 0)), t[n] === null && (t[n] = void 0);
    !f(ae.beforeQueryHandler, { CrudState: d.value, Data: t }) || de.value({
      url: r.url,
      name: $.value.ApiName.query,
      data: {
        pagenum: $.value.Page_PageParams.current,
        pagesize: $.value.Page_PageParams.pageSize,
        ...t
      }
    }).then((n) => {
      const { data: F, page: S } = n;
      setTimeout(() => {
        a(F, t), $.value.Page_PageParams.total = S.total, d.value.tableLoading = !1;
      }, 50);
    }).catch(() => {
      d.value.tableLoading = !1;
    });
  }
  const a = (t, n) => {
    Object.keys(n).filter((S) => n[S] != null).length == 0 && (d.value.originalData = t), d.value.originalData = ne(t), f(ae.afterQueryHandler, { CrudState: d.value, Data: t }) && (d.value.tableData = ne(t));
  };
  function C() {
    d.value.editModel = ne(d.value.initEditModel);
    const t = te({ ...d.value.editModel });
    !f(ae.beforeAddHandler, { CrudState: d.value, Data: t }) || (d.value.Mode = "add", d.value.DialogVisible = !0);
  }
  const D = (t) => {
    const n = te({
      ...t
    });
    if (!f(ae.beforeEditHandler, { CrudState: d.value, Data: n }))
      return;
    const F = ne(n);
    Object.keys(F).forEach((S) => {
      d.value.editModel[S] = F[S], d.value.editFormValue[S] = F[S];
    }), d.value.Mode = "edit", d.value.DialogVisible = !0;
  }, P = async (t) => {
    !t || await t.validate((n) => {
      if (n) {
        const F = te({
          ...d.value.editModel
        });
        if (!f(ae.beforeSubmitHandler, { CrudState: d.value, Data: F }))
          return;
        d.value.Mode === "add" ? h(F) : E(F);
      }
    });
  }, h = (t) => {
    d.value.submitLoading = !0;
    let n = t;
    t.FormData instanceof FormData && (n = t.FormData), de.value({ url: r.url, name: $.value.ApiName.add, data: n }).then(() => {
      d.value.DialogVisible = !1, me("\u65B0\u589E\u6210\u529F"), m(), d.value.submitLoading = !1;
    }).catch(() => {
      d.value.submitLoading = !1;
    });
  }, E = (t) => {
    d.value.submitLoading = !1;
    let n = t;
    if (t.FormData instanceof FormData)
      n = t.FormData;
    else {
      const F = Ie(d.value.editModel, n);
      if (JSON.stringify(F) === "{}")
        return d.value.submitLoading = !1, Me({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
      n = {
        ...p(t),
        ...F
      };
    }
    de.value({ url: r.url, name: $.value.ApiName.edit, data: n }).then(() => {
      d.value.DialogVisible = !1, me("\u7F16\u8F91\u6210\u529F"), m(), d.value.submitLoading = !1;
    }).catch(() => {
      d.value.submitLoading = !1;
    });
  };
  return {
    queryRecord: m,
    addRecord: C,
    editRecord: D,
    handleSubmit: P,
    delFlag: (t) => {
      Ee.confirm(`\u786E\u5B9A\u8981 \u201C${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = te({
          ...p(t),
          deleteFlag: t.deleteFlag == 0 ? 1 : 0
        });
        !f(ae.beforedisabledHandler, { CrudState: d.value, Data: n }) || de.value({
          url: r.url,
          name: $.value.ApiName.deleteFlag,
          data: n
        }).then(() => {
          me(`\u6570\u636E${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), m();
        });
      }).catch(() => {
      });
    },
    deleteRecord: (t) => {
      Ee.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = te({
          ...p(t)
        });
        !f(ae.beforeDeteleHandler, { CrudState: d.value, Data: n }) || de.value({
          url: r.url,
          name: $.value.ApiName.delete,
          data: n
        }).then(() => {
          me("\u5220\u9664\u6210\u529F"), m();
        });
      }).catch(() => {
      });
    },
    deleteMulRecord: () => {
      const t = d.value.multipleSelection.map((n) => n[r.rowKey]);
      Ee.confirm(`\u786E\u5B9A\u8981\u5220\u9664\u8FD9 ${t.length} \u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = te({
          [r.rowKey]: t,
          selection: d.value.multipleSelection
        });
        !f(ae.beforeBatchDeteleHandler, { CrudState: d.value, Data: n }) || de.value({
          url: r.url,
          name: $.value.ApiName.remove,
          data: n
        }).then(() => {
          me("\u6279\u91CF\u5220\u9664\u6210\u529F"), d.value.multipleSelection = [], d.value.CompRef.TableRef.clearSelection(), m();
        });
      }).catch(() => {
      });
    }
  };
};
function be(...r) {
  $.value.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...r);
}
const Je = (r) => {
  const { filter: p, editor: f, column: m, columns: a } = r;
  let C = {};
  p.forEach((P) => {
    try {
      C[P] = a[P].searchDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", P);
    }
    d.value.ElementArrs.filter[P] = a[P];
  }), d.value.initSearchModel = ne(C), d.value.searchModel = ne(d.value.initSearchModel);
  let D = {};
  f.forEach((P) => {
    try {
      D[P] = a[P].addDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", P);
    }
    d.value.ElementArrs.editor[P] = a[P];
  }), d.value.initEditModel = ne(D), m.forEach((P) => {
    d.value.ElementArrs.column[P] = a[P];
  }), d.value.ElementArrs.columns = a;
};
ve(() => {
  let r = [];
  for (const p in d.value.ElementArrs.editor)
    Object.prototype.hasOwnProperty.call(d.value.ElementArrs.editor, p) && d.value.ElementArrs.editor[p].type === "el-upload" && r.push(p);
  return r;
});
const me = (r, p = "success") => {
  Ne({
    title: r,
    type: p,
    offset: 70,
    duration: 2500
  });
}, Ge = /* @__PURE__ */ ge({
  __name: "crud_SearchForm",
  setup(r) {
    const p = x(), { Form_LabelWidth: f } = he(), {
      CompRef: m,
      searchModel: a,
      ElementArrs: {
        value: { filter: C }
      }
    } = k();
    De(() => {
      m.value.SearchFormRef = p.value;
    });
    const D = (h) => {
      var E, V;
      return h.range ? (E = h.formProps) != null && E.type ? h.formProps.type + "range" : "daterange" : (V = h.formProps) != null && V.type ? h.formProps.type : "date";
    }, P = (h, E, V) => {
      a.value[E] === V ? a.value[E] = void 0 : a.value[E] = h.formProps.options[V].value;
    };
    return (h, E) => {
      const V = _("el-input"), T = _("el-form-item"), U = _("el-col"), t = _("el-input-number"), n = _("el-option"), F = _("el-select"), S = _("el-date-picker"), L = _("el-time-picker"), ue = _("el-radio"), Y = _("el-radio-button"), j = _("el-radio-group"), se = _("el-row"), Z = _("el-form"), ee = _("el-collapse-transition");
      return i(), v(ee, null, {
        default: o(() => [
          G("div", null, [
            A(h.$slots, "search-form", {}, void 0, !0),
            s(Z, {
              ref_key: "SearchFormRef",
              ref: p,
              model: e(a),
              "label-width": e(f)
            }, {
              default: o(() => [
                s(se, null, {
                  default: o(() => [
                    A(h.$slots, "search-form-top", {}, void 0, !0),
                    (i(!0), N(K, null, W(e(C), (u, y) => {
                      var Q;
                      return i(), N(K, null, [
                        u.type === "el-input" ? (i(), v(U, {
                          key: 0,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(T, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(V, w({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  clearable: "",
                                  placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-input-number" ? (i(), v(U, {
                          key: 1,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(T, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(t, w({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-select" ? (i(), v(U, {
                          key: 2,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(T, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(F, w({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9"
                                }, u.formProps), {
                                  default: o(() => [
                                    (i(!0), N(K, null, W(u.formProps.options, (g) => (i(), v(n, {
                                      key: g.value,
                                      label: g.label,
                                      value: g.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" && !D(u).includes("range") ? (i(), v(U, {
                          key: 3,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(T, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(S, w({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  "range-separator": "\u81F3",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" ? (i(), v(U, {
                          key: 4,
                          span: u.span ? u.span : 12
                        }, {
                          default: o(() => [
                            s(T, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(S, w({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, {
                                  type: D(u)
                                }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" && !((Q = u.formProps) != null && Q.isRange) && !u.range ? (i(), v(U, {
                          key: 5,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(T, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(L, w({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" ? (i(), v(U, {
                          key: 6,
                          span: u.span ? u.span : 12
                        }, {
                          default: o(() => [
                            s(T, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(L, w({
                                  style: { width: "100%" },
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, { "is-range": "" }), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-radio-group" ? (i(), v(U, {
                          key: 7,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            s(T, {
                              label: u.label,
                              prop: y
                            }, {
                              default: o(() => [
                                s(j, w({
                                  modelValue: e(a)[y],
                                  "onUpdate:modelValue": (g) => e(a)[y] = g
                                }, u.formProps), {
                                  default: o(() => [
                                    u.formProps.button ? z("", !0) : (i(!0), N(K, { key: 0 }, W(u.formProps.options, (g) => (i(), v(ue, w({
                                      key: g.value,
                                      label: g.value,
                                      onClick: Ce((le) => P(u, y, g.value), ["prevent"])
                                    }, u.formProps), {
                                      default: o(() => [
                                        q(re(g.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    u.formProps.button ? (i(!0), N(K, { key: 1 }, W(u.formProps.options, (g) => (i(), v(Y, w({
                                      key: g.value,
                                      label: g.value,
                                      onClick: Ce((le) => P(u, y, g.value), ["prevent"])
                                    }, u.formProps), {
                                      default: o(() => [
                                        q(re(g.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64);
                    }), 256)),
                    A(h.$slots, "search-form-bottom", {}, void 0, !0)
                  ]),
                  _: 3
                })
              ]),
              _: 3
            }, 8, ["model", "label-width"])
          ])
        ]),
        _: 3
      });
    };
  }
});
const we = (r, p) => {
  const f = r.__vccOpts || r;
  for (const [m, a] of p)
    f[m] = a;
  return f;
}, Xe = /* @__PURE__ */ we(Ge, [["__scopeId", "data-v-394e11ba"]]), Ye = { class: "edit" }, Ze = { class: "edit_form" }, el = /* @__PURE__ */ ge({
  __name: "crud_EditForm",
  props: {
    height: Number
  },
  setup(r) {
    const p = x(), { Form_LabelWidth: f } = he(), {
      CompRef: m,
      editModel: a,
      Mode: C,
      ElementArrs: {
        value: { editor: D }
      },
      uploadFiles: P
    } = k();
    De(() => {
      m.value.EditFormRef = p.value;
    });
    const h = ve(() => {
      let t = {};
      return He().source.value.editor.forEach((n) => {
        typeof D[n].visible == "function" ? D[n].visible(k(), C.value) && (t[n] = D[n]) : t[n] = D[n];
      }), t;
    }), E = ({ showFileList: t }) => {
      if (t)
        return !1;
      if (P.value[0])
        return URL.createObjectURL(P.value[0]);
    }, V = (t) => typeof t.disabled == "function" ? t.disabled(k(), C.value) : !1, T = (t) => {
      let n = { ...t };
      return Object.keys(n).forEach((F) => {
        typeof n[F] == "function" && (n[F] = n[F].bind(this, k()));
      }), n;
    }, U = (t, n, F) => {
      a.value[n] === F ? a.value[n] = void 0 : a.value[n] = t.formProps.options[F].value;
    };
    return (t, n) => {
      const F = _("el-input"), S = _("el-form-item"), L = _("el-col"), ue = _("el-input-number"), Y = _("el-option"), j = _("el-select"), se = _("el-date-picker"), Z = _("el-time-picker"), ee = _("el-cascader"), u = _("el-button"), y = _("el-image"), Q = _("plus"), g = _("el-icon"), le = _("el-upload"), ie = _("el-radio"), pe = _("el-radio-button"), ce = _("el-radio-group"), R = _("el-row"), O = _("el-form"), M = _("el-scrollbar");
      return i(), N("div", Ye, [
        s(M, {
          height: r.height,
          "max-height": r.height
        }, {
          default: o(() => [
            G("div", Ze, [
              A(t.$slots, "edit-form", { editModel: e(a) }, void 0, !0),
              s(O, {
                ref_key: "EditFormRef",
                ref: p,
                model: e(a),
                "label-width": e(f)
              }, {
                default: o(() => [
                  s(R, null, {
                    default: o(() => [
                      A(t.$slots, "edit-form-top", { editModel: e(a) }, void 0, !0),
                      (i(!0), N(K, null, W(e(h), (l, c) => (i(), N(K, { key: c }, [
                        l.type === "el-input" ? (i(), v(L, {
                          key: 0,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: c,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(F, w({
                                  style: { width: "100%" },
                                  modelValue: e(a)[c],
                                  "onUpdate:modelValue": (b) => e(a)[c] = b,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-input-number" ? (i(), v(L, {
                          key: 1,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: c,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(ue, w({
                                  style: { width: "100%" },
                                  modelValue: e(a)[c],
                                  "onUpdate:modelValue": (b) => e(a)[c] = b,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-select" ? (i(), v(L, {
                          key: 2,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: c,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(j, w({
                                  style: { width: "100%" },
                                  modelValue: e(a)[c],
                                  "onUpdate:modelValue": (b) => e(a)[c] = b,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  disabled: V(l)
                                }, l.formProps), {
                                  default: o(() => [
                                    (i(!0), N(K, null, W(l.formProps.options, (b) => (i(), v(Y, {
                                      key: b.value,
                                      label: b.label,
                                      value: b.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-date-picker" ? (i(), v(L, {
                          key: 3,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: c,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(se, w({
                                  style: { width: "100%" },
                                  modelValue: e(a)[c],
                                  "onUpdate:modelValue": (b) => e(a)[c] = b,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-time-picker" ? (i(), v(L, {
                          key: 4,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: c,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(Z, w({
                                  style: { width: "100%" },
                                  modelValue: e(a)[c],
                                  "onUpdate:modelValue": (b) => e(a)[c] = b,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-cascader" ? (i(), v(L, {
                          key: 5,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: c,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(ee, w({
                                  style: { width: "100%" },
                                  modelValue: e(a)[c],
                                  "onUpdate:modelValue": (b) => e(a)[c] = b,
                                  props: l.formProps.props,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  "show-all-levels": !1,
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-upload" ? (i(), v(L, {
                          key: 6,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: c,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(le, w({
                                  style: { width: "100%" },
                                  ref_for: !0,
                                  ref: c + "UploadRef",
                                  action: ""
                                }, T(l.formProps)), {
                                  default: o(() => {
                                    var b;
                                    return [
                                      ((b = l.formProps) == null ? void 0 : b.listType) !== "picture-card" ? (i(), v(u, {
                                        key: 0,
                                        type: "primary"
                                      }, {
                                        default: o(() => [
                                          q(re(l.formProps.butName || "\u70B9\u51FB\u4E0A\u4F20\u6587\u4EF6"), 1)
                                        ]),
                                        _: 2
                                      }, 1024)) : z("", !0),
                                      l.formProps.listType === "picture-card" && E(l.formProps) ? (i(), v(y, {
                                        key: 1,
                                        style: { width: "146px", height: "146px", "border-radius": "5px" },
                                        fit: "contain",
                                        src: E(l.formProps)
                                      }, null, 8, ["src"])) : z("", !0),
                                      l.formProps.listType == "picture-card" && !E(l.formProps) ? (i(), v(g, { key: 2 }, {
                                        default: o(() => [
                                          s(Q)
                                        ]),
                                        _: 1
                                      })) : z("", !0)
                                    ];
                                  }),
                                  _: 2
                                }, 1040)
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-radio-group" ? (i(), v(L, {
                          key: 7,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            s(S, {
                              label: l.label,
                              prop: c,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                s(ce, w({
                                  modelValue: e(a)[c],
                                  "onUpdate:modelValue": (b) => e(a)[c] = b,
                                  disabled: V(l)
                                }, l.formProps), {
                                  default: o(() => [
                                    l.formProps.button ? z("", !0) : (i(!0), N(K, { key: 0 }, W(l.formProps.options, (b) => (i(), v(ie, w({
                                      key: b.value,
                                      label: b.value,
                                      onClick: Ce((fe) => U(l, c, b.value), ["prevent"])
                                    }, l.formProps), {
                                      default: o(() => [
                                        q(re(b.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    l.formProps.button ? (i(!0), N(K, { key: 1 }, W(l.formProps.options, (b) => (i(), v(pe, w({
                                      key: b.value,
                                      label: b.value,
                                      onClick: Ce((fe) => U(l, c, b.value), ["prevent"])
                                    }, l.formProps), {
                                      default: o(() => [
                                        q(re(b.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64))), 128)),
                      A(t.$slots, "edit-form-bottom", { editModel: e(a) }, void 0, !0)
                    ]),
                    _: 3
                  })
                ]),
                _: 3
              }, 8, ["model", "label-width"])
            ])
          ]),
          _: 3
        }, 8, ["height", "max-height"])
      ]);
    };
  }
});
const ll = /* @__PURE__ */ we(el, [["__scopeId", "data-v-08532dff"]]), ol = { key: 1 }, al = /* @__PURE__ */ ge({
  __name: "crud_Table",
  props: { height: Number },
  emits: ["row-contextmenu"],
  setup(r, { emit: p }) {
    const f = x(), { Table_isOpenMultipleSelection: m, Table_isOpenIndex: a, Table_isOpenExpand: C, Table_ExpandColumn: D, Table_MenuAlign: P, Table_MenuWidth: h, Page_PageParams: E, Permission: V } = he(), {
      CompRef: T,
      tableData: U,
      tableLoading: t,
      ElementArrs: {
        value: { filter: n, column: F, columns: S }
      },
      searchModel: L,
      multipleSelection: ue
    } = k(), { rowKey: Y, keyName: j, Table_Attributes: se } = He(), { queryRecord: Z, editRecord: ee, delFlag: u, deleteRecord: y } = Be();
    De(() => {
      T.value.TableRef = f.value;
    });
    const Q = ve(() => {
      var R, O;
      return (((R = E == null ? void 0 : E.value) == null ? void 0 : R.current) - 1) * ((O = E == null ? void 0 : E.value) == null ? void 0 : O.pageSize) + 1;
    }), g = (R) => {
      ue.value = R;
    }, le = (R, O, M, l) => {
      O.label && navigator.clipboard.writeText(M.innerText).then(() => {
        Me.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, ie = (R, O, M) => {
      M.preventDefault(), p("row-contextmenu", { row: R, column: O, event: M }, k());
    }, pe = (R, O, M) => {
      if (O.formProps) {
        const l = O.formProps.options.findIndex((c) => c.value == R[M]);
        return l === -1 ? R[M] : O.formProps.options[l].label;
      } else
        return R[M];
    }, ce = (R, O) => {
      let M = { ...R };
      return Object.keys(M).forEach((l) => {
        typeof M[l] == "function" && (M[l] = M[l].call(this, k(), O));
      }), M;
    };
    return (R, O) => {
      const M = _("el-empty"), l = _("el-table-column"), c = _("el-descriptions-item"), b = _("el-descriptions"), fe = _("el-input"), _e = _("el-button"), I = _("el-table"), ke = Re("loading");
      return ye((i(), v(I, w({
        ref_key: "TableRef",
        ref: f,
        data: e(U),
        "row-key": e(Y),
        height: r.height,
        onCellDblclick: le,
        onSelectionChange: g,
        onRowContextmenu: ie
      }, e(se)), {
        empty: o(() => [
          s(M, {
            "image-size": 80,
            description: "\u6682\u65E0\u6570\u636E"
          })
        ]),
        default: o(() => [
          e(m) ? (i(), v(l, {
            key: 0,
            type: "selection",
            "reserve-selection": "",
            width: 44
          })) : z("", !0),
          e(C) ? (i(), v(l, {
            key: 1,
            type: "expand",
            width: 55
          }, {
            default: o((H) => [
              s(b, {
                column: e(D),
                border: ""
              }, {
                default: o(() => [
                  (i(!0), N(K, null, W(e(S), (J, Fe) => (i(), N(K, { key: Fe }, [
                    J.hidden ? z("", !0) : (i(), v(c, {
                      key: 0,
                      label: J.label
                    }, {
                      default: o(() => [
                        q(re(pe(H.row, J, Fe)), 1)
                      ]),
                      _: 2
                    }, 1032, ["label"]))
                  ], 64))), 128))
                ]),
                _: 2
              }, 1032, ["column"])
            ]),
            _: 1
          })) : z("", !0),
          e(a) ? (i(), v(l, {
            key: 2,
            label: "###",
            width: 55,
            "show-overflow-tooltip": ""
          }, {
            default: o(({ $index: H }) => [
              q(re(e(Q) + H), 1)
            ]),
            _: 1
          })) : z("", !0),
          (i(!0), N(K, null, W(e(F), (H, J) => (i(), v(l, w({
            key: J,
            align: H.align || "left",
            label: H.label,
            prop: J
          }, H.tableProps, { "show-overflow-tooltip": "" }), Ae({ _: 2 }, [
            H.columnSlot ? {
              name: "default",
              fn: o((Fe) => [
                (i(), v(Oe(H.columnSlot.is), Te(xe(ce(H.columnSlot, Fe))), null, 16))
              ])
            } : void 0
          ]), 1040, ["align", "label", "prop"]))), 128)),
          A(R.$slots, "table-column"),
          s(l, {
            align: e(P) || "left",
            width: e(h)
          }, {
            header: o(() => [
              e(j) ? (i(), v(fe, {
                key: 0,
                modelValue: e(L)[e(j)],
                "onUpdate:modelValue": O[0] || (O[0] = (H) => e(L)[e(j)] = H),
                placeholder: e(n)[e(j)].label + "\u6A21\u7CCA\u67E5\u627E",
                clearable: "",
                onKeyup: $e(e(Z), ["enter", "native"])
              }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : (i(), N("span", ol, "\u64CD\u4F5C"))
            ]),
            default: o((H) => [
              A(R.$slots, "menu-top", { scope: H }),
              s(_e, {
                plain: "",
                type: H.row[e(V).deleteFlag] ? "danger" : "success",
                onClick: (J) => e(u)(H.row)
              }, {
                default: o(() => [
                  q(re(H.row[e(V).deleteFlag] ? "\u7981\u7528" : "\u542F\u7528"), 1)
                ]),
                _: 2
              }, 1032, ["type", "onClick"]),
              s(_e, {
                plain: "",
                type: "primary",
                icon: "edit",
                onClick: (J) => e(ee)(H.row)
              }, null, 8, ["onClick"]),
              s(_e, {
                plain: "",
                type: "danger",
                icon: "delete",
                onClick: (J) => e(y)(H.row)
              }, null, 8, ["onClick"]),
              A(R.$slots, "menu-bottom", { scope: H })
            ]),
            _: 3
          }, 8, ["align", "width"])
        ]),
        _: 3
      }, 16, ["data", "row-key", "height"])), [
        [ke, e(t)]
      ]);
    };
  }
}), tl = /* @__PURE__ */ ge({
  __name: "crud_Pagination",
  setup(r) {
    const { Page_PageSizes: p, Page_PageParams: f, Page_Layout: m, Page_isHideOnSinglePage: a } = he(), { queryRecord: C } = Be(), D = (h) => {
      f.value.pageSize = h, C();
    }, P = (h) => {
      f.value.current = h, f.value.current != null && C();
    };
    return (h, E) => {
      const V = _("el-pagination");
      return i(), v(V, {
        "hide-on-single-page": e(a),
        "current-page": e(f).current,
        "page-size": e(f).pageSize,
        "page-sizes": e(p),
        background: "",
        layout: e(m),
        total: e(f).total,
        onSizeChange: D,
        onCurrentChange: P
      }, null, 8, ["hide-on-single-page", "current-page", "page-size", "page-sizes", "layout", "total"]);
    };
  }
}), nl = { style: { padding: "20px", "background-color": "#fff" } }, rl = { class: "button_left" }, ul = /* @__PURE__ */ q(" \u65B0\u589E "), sl = /* @__PURE__ */ q(" \u6279\u91CF\u5220\u9664 "), dl = { class: "button_right" }, il = { style: { display: "flex", "justify-content": "flex-end" } }, pl = /* @__PURE__ */ q("\u53D6\u6D88"), cl = /* @__PURE__ */ q("\u91CD\u7F6E"), fl = /* @__PURE__ */ q("\u63D0\u4EA4"), _l = /* @__PURE__ */ ge({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    debug: { type: Boolean, default: () => B.debug },
    mainMaxHeight: { default: () => B.mainMaxHeight },
    isAfterMountQuery: { type: Boolean, default: () => B.isAfterMountQuery },
    isOpenSearchForm: { type: Boolean, default: () => B.isOpenSearchForm },
    Form_LabelWidth: { default: () => B.Form_LabelWidth },
    Dialog_Width: { default: () => B.Dialog_Width },
    Dialog_isFullscreen: { type: Boolean, default: () => B.Dialog_isFullscreen },
    Dialog_isCloseOnPressEscape: { type: Boolean, default: () => B.Dialog_isCloseOnPressEscape },
    Dialog_isCloseOnClickModal: { type: Boolean, default: () => B.Dialog_isCloseOnClickModal },
    Dialog_isFooterButton: { type: Boolean, default: () => B.Dialog_isFooterButton },
    Table_Attributes: null,
    Table_isOpenIndex: { type: Boolean, default: () => B.Table_isOpenIndex },
    Table_isOpenMultipleSelection: { type: Boolean, default: () => B.Table_isOpenMultipleSelection },
    Table_isOpenExpand: { type: Boolean, default: () => B.Table_isOpenExpand },
    Table_ExpandColumn: { default: () => B.Table_ExpandColumn },
    Page_PageSizes: { default: () => B.Page_PageSizes },
    Page_PageParams: { default: () => B.Page_PageParams },
    Page_Layout: { default: () => B.Page_Layout },
    Page_isHideOnSinglePage: { type: Boolean, default: () => B.Page_isHideOnSinglePage },
    ApiName: { default: () => B.ApiName },
    Permission: { default: () => B.Permission },
    Permissions: { default: () => B.Permissions }
  },
  emits: ["row-contextmenu"],
  setup(r, { emit: p }) {
    const f = r, m = qe();
    Qe(f);
    const { queryRecord: a, addRecord: C, handleSubmit: D, deleteMulRecord: P } = Be(), { CompRef: h, initSearchModel: E, Mode: V, DialogVisible: T, multipleSelection: U, submitLoading: t, DialogVisibleFooterButton: n } = k(), { isOpenSearchForm: F, isAfterMountQuery: S, Table_isOpenMultipleSelection: L, Dialog_Width: ue, Dialog_isFullscreen: Y, Dialog_isCloseOnPressEscape: j, Dialog_isCloseOnClickModal: se, Permission: Z, Permissions: ee } = he();
    if (m.params.data) {
      be("\u8DEF\u7531\u4F20\u53C2\uFF1A", m.params.data);
      let l = m.params.data, c = JSON.parse(l);
      E.value = Pe(E.value, c);
    }
    const u = x(), y = x(), Q = x(), g = x(), le = x(0), ie = x(0), pe = x(0), ce = x(0);
    De(() => {
      h.value.containerDivRef = u.value, h.value.searchDivRef = y.value, h.value.buttonDivRef = Q.value, h.value.paginationDivRef = g.value, le.value = u.value.offsetHeight - 40, ie.value = h.value.searchDivRef.offsetHeight, pe.value = h.value.buttonDivRef.offsetHeight, ce.value = h.value.paginationDivRef.offsetHeight, S.value && a();
    });
    const R = ve(() => {
      const l = x(le.value - pe.value - ce.value);
      return F.value ? l.value - ie.value : l.value;
    }), O = ve(() => {
      const l = x(document.documentElement.clientHeight);
      return Y.value ? l.value - 54 - 62 - 2 : l.value - 54 - 62 - 2 - l.value * 0.15 - 50;
    }), M = ({ row: l, event: c }, b) => {
      p("row-contextmenu", { row: l, event: c }, b);
    };
    return (l, c) => {
      var fe, _e;
      const b = Re("Auth");
      return i(), N("div", {
        ref_key: "containerDivRef",
        ref: u,
        style: { height: "100%" }
      }, [
        G("div", nl, [
          G("div", {
            ref_key: "searchDivRef",
            ref: y
          }, [
            ye(s(Xe, null, {
              "search-form": o(() => [
                A(l.$slots, "search-form", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              "search-form-top": o(() => [
                A(l.$slots, "search-form-top", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              "search-form-bottom": o(() => [
                A(l.$slots, "search-form-bottom", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              _: 3
            }, 512), [
              [Ue, e(F)]
            ])
          ], 512),
          G("div", {
            ref_key: "buttonDivRef",
            ref: Q,
            class: "buttonDiv"
          }, [
            G("div", rl, [
              ye((i(), v(e(oe), {
                type: "primary",
                icon: "plus",
                onClick: e(C)
              }, {
                default: o(() => [
                  ul
                ]),
                _: 1
              }, 8, ["onClick"])), [
                [b, { Permissions: e(ee), access: [(fe = e(Z)) == null ? void 0 : fe.add] }]
              ]),
              e(L) ? ye((i(), v(e(oe), {
                key: 0,
                disabled: e(U).length <= 0,
                type: "danger",
                icon: "delete",
                onClick: e(P)
              }, {
                default: o(() => [
                  sl
                ]),
                _: 1
              }, 8, ["disabled", "onClick"])), [
                [b, { Permissions: e(ee), access: [(_e = e(Z)) == null ? void 0 : _e.remove] }]
              ]) : z("", !0),
              A(l.$slots, "button-left", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            G("div", dl, [
              A(l.$slots, "button-right", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            s(e(ze), { style: { "flex-shrink": "0", width: "150px" } }, {
              default: o(() => [
                s(e(oe), {
                  color: "#67c23a",
                  icon: "search",
                  onClick: e(a)
                }, null, 8, ["onClick"]),
                s(e(oe), {
                  color: "#e6a23c",
                  icon: "refresh",
                  onClick: c[0] || (c[0] = (I) => e(h).SearchFormRef.resetFields())
                }),
                s(e(oe), {
                  color: "#409eff",
                  icon: "expand",
                  onClick: c[1] || (c[1] = (I) => F.value = !e(F))
                })
              ]),
              _: 1
            })
          ], 512),
          s(al, {
            height: e(R),
            onRowContextmenu: M
          }, {
            "table-column": o(() => [
              A(l.$slots, "table-column", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            "menu-top": o((I) => [
              A(l.$slots, "menu-top", {
                scope: I,
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            "menu-bottom": o((I) => [
              A(l.$slots, "menu-bottom", {
                scope: I,
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            _: 3
          }, 8, ["height"]),
          G("div", {
            ref_key: "paginationDivRef",
            ref: g,
            style: { "padding-top": "20px" }
          }, [
            s(tl)
          ], 512),
          s(e(Ke), {
            class: "DialogVisible",
            modelValue: e(T),
            "onUpdate:modelValue": c[5] || (c[5] = (I) => Le(T) ? T.value = I : null),
            title: e(V) === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: e(ue),
            "close-on-press-escape": e(j),
            fullscreen: e(Y),
            "close-on-click-modal": e(se)
          }, Ae({
            default: o(() => [
              s(ll, { height: e(O) }, {
                "edit-form": o(() => [
                  A(l.$slots, "edit-form", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                "edit-form-top": o(() => [
                  A(l.$slots, "edit-form-top", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                "edit-form-bottom": o(() => [
                  A(l.$slots, "edit-form-bottom", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                _: 3
              }, 8, ["height"])
            ]),
            _: 2
          }, [
            e(n) ? {
              name: "footer",
              fn: o(() => [
                G("div", il, [
                  A(l.$slots, "edit-form-footer", {}, void 0, !0),
                  s(e(oe), {
                    onClick: c[2] || (c[2] = (I) => T.value = !1)
                  }, {
                    default: o(() => [
                      pl
                    ]),
                    _: 1
                  }),
                  s(e(oe), {
                    type: "warning",
                    plain: "",
                    onClick: c[3] || (c[3] = (I) => e(h).EditFormRef.resetFields())
                  }, {
                    default: o(() => [
                      cl
                    ]),
                    _: 1
                  }),
                  s(e(oe), {
                    type: "primary",
                    loading: e(t),
                    onClick: c[4] || (c[4] = (I) => e(D)(e(h).EditFormRef))
                  }, {
                    default: o(() => [
                      fl
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "close-on-press-escape", "fullscreen", "close-on-click-modal"])
        ])
      ], 512);
    };
  }
});
const Se = /* @__PURE__ */ we(_l, [["__scopeId", "data-v-5ef8660f"]]), ml = {
  mounted(r, p, f) {
  }
};
Se.install = (r) => {
  r.component("CrudEl", Se), r.directive("Auth", ml);
};
const hl = (r, p) => {
  p ? (p.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), We(p), r.use(Se)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  Pe as DataMerger,
  ne as DeepClone,
  We as InitSys,
  hl as createCrudEl,
  ae as hooksName,
  Ie as isObjEqual,
  je as useHooks
};
